/**
 * Sencha GXT 3.1.1 - Sencha for GWT
 * Copyright(c) 2007-2014, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://www.sencha.com/products/gxt/license/
 */
package com.dldinternet.aws.cfn.stacker.desktopapp.client.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.dldinternet.aws.cfn.stacker.desktopapp.client.event.RemoveFileModelEvent.RemoveFileModelHandler;
import com.dldinternet.aws.cfn.stacker.desktopapp.client.persistence.FileModel;

public class RemoveFileModelEvent extends GwtEvent<RemoveFileModelHandler> {

  public interface RemoveFileModelHandler extends EventHandler {
    void onRemoveFileModel(RemoveFileModelEvent event);
  }

  public static Type<RemoveFileModelHandler> TYPE = new Type<RemoveFileModelHandler>();
  private FileModel fileModel;

  public RemoveFileModelEvent(FileModel fileModel) {
    this.fileModel = fileModel;
  }

  @Override
  public Type<RemoveFileModelHandler> getAssociatedType() {
    return TYPE;
  }

  public FileModel getFileModel() {
    return fileModel;
  }

  @Override
  protected void dispatch(RemoveFileModelHandler handler) {
    handler.onRemoveFileModel(this);
  }
}